---
title: CanvasRenderingContext2D.strokeRect()
slug: Web/API/CanvasRenderingContext2D/strokeRect
tags:
  - API
  - Canvas
  - CanvasRenderingContext2D
  - Method
  - Reference
---
<div>{{APIRef}}</div>

<p>The <code><strong>CanvasRenderingContext2D</strong></code><strong><code>.strokeRect()</code></strong> method of the Canvas 2D API draws a rectangle that is stroked (outlined) according to the current {{domxref("CanvasRenderingContext2D.strokeStyle", "strokeStyle")}} and other context settings.</p>

<p>This method draws directly to the canvas without modifying the current path, so any subsequent {{domxref("CanvasRenderingContext2D.fill()", "fill()")}} or {{domxref("CanvasRenderingContext2D.stroke()", "stroke()")}} calls will have no effect on it.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <em>ctx</em>.strokeRect(<em>x</em>, <em>y</em>, <em>width</em>, <em>height</em>);
</pre>

<p>The <code>strokeRect()</code> method draws a stroked rectangle whose starting point is at <code>(x, y)</code> and whose size is specified by <code>width</code> and <code>height</code>.</p>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>x</code></dt>
 <dd>The x-axis coordinate of the rectangle's starting point.</dd>
 <dt><code>y</code></dt>
 <dd>The y-axis coordinate of the rectangle's starting point.</dd>
 <dt><code>width</code></dt>
 <dd>The rectangle's width. Positive values are to the right, and negative to the left.</dd>
 <dt><code>height</code></dt>
 <dd>The rectangle's height. Positive values are down, and negative are up.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="A_simple_stroked_rectangle">A simple stroked rectangle</h3>

<p>This example draws a rectangle with a green outline using the <code>strokeRect()</code> method.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<p>The rectangle's top-left corner is at (20, 10). It has a width of 160 and a height of 100.</p>

<pre class="brush: js; highlight:[4]">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');
ctx.strokeStyle = 'green';
ctx.strokeRect(20, 10, 160, 100);
</pre>

<h4 id="Result">Result</h4>

<p>{{ EmbedLiveSample('A_simple_stroked_rectangle', 700, 180) }}</p>

<h3 id="Applying_various_context_settings">Applying various context settings</h3>

<p>This example draws a rectangle with a drop shadow and thick, beveled outlines.</p>

<h4 id="HTML_2">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript_2">JavaScript</h4>

<pre class="brush: js">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');
ctx.shadowColor = '#d53';
ctx.shadowBlur = 20;
ctx.lineJoin = 'bevel';
ctx.lineWidth = 15;
ctx.strokeStyle = '#38f';
ctx.strokeRect(30, 30, 160, 90);</pre>

<h4 id="Result_2">Result</h4>

<p>{{ EmbedLiveSample('Applying_various_context_settings', 700, 180) }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "scripting.html#dom-context-2d-strokerect", "CanvasRenderingContext2D.strokeRect")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CanvasRenderingContext2D.strokeRect")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The interface defining this method: {{domxref("CanvasRenderingContext2D")}}</li>
 <li>{{domxref("CanvasRenderingContext2D.strokeStyle")}}</li>
 <li>{{domxref("CanvasRenderingContext2D.clearRect()")}}</li>
 <li>{{domxref("CanvasRenderingContext2D.fillRect()")}}</li>
</ul>
